



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>北京地铁月度消费总金额计算(Python版)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">北京地铁月度消费总金额计算(Python版)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 12:30:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　最近业余时间在学习Python，这是那天坐地铁时突发奇想，想看看我这一个月的地铁费共多少钱，所以简单的构思了下思路，就直接开写了，没想到用Python来实现还挺简单的。</p>
<p>设计思路：</p>
<p>　　每次乘车正常消费7元，每天乘车2次，每月工作日乘车22天。</p>
<p>　　每月乘车总金额超过100元，下次乘车票价的8折</p>
<p>　　每月乘车总金额超过150元，下次乘车票价的5折</p>
<p>　　每月乘车总金额超过400元，下次乘车不打折</p>
<p>代码：</p>
<div>
<pre class="prettyprint linenums"> # _*_coding=utf-8 _*_<br />
 __author__ = 'Xue'

 '''<br />
 计算北京地铁每月乘车票价总金额<br />
 version 1.0<br />
 默认：每次乘车x元，每天乘车2次，每月乘车22天

 每月乘车总金额超过100元，下次乘车票价的8折<br />
 每月乘车总金额超过150元，下次乘车票价的5折<br />
 每月乘车总金额超过400元，下次乘车不打折

 '''

 def way():<br />
     dayMoney=int(raw_input("请输入您单次乘车正常票价(单位:元)："))<br />
     dayTime=raw_input("请输入您每天乘车次数(默认2次)：")<br />
     dayMonth=raw_input("请输入您每月乘车天数(默认22天)：")<br />
     dayAllMoney=0.0 #当月乘车总金额

     #统计各阶段乘车的钱数和次数和<br />
     m100=0.0<br />
     m150=0.0<br />
     m400=0.0<br />
     mmax=0.0<br />
     t100=0<br />
     t150=0<br />
     t400=0<br />
     tmax=0

     if dayTime=='':<br />
         dayTime=2<br />
     else:<br />
         dayTime=int(dayTime)  #格式转换

     if dayMonth=='':<br />
         dayMonth=22<br />
     else:<br />
         dayMonth=int(dayMonth) #格式转换

     dayMonthTime=dayTime*dayMonth #每月总乘车次数<br />
     dayNowTime=0  #乘车次数记录

     while dayNowTime&lt;=dayMonthTime:

         if dayAllMoney&lt;=100.0: #总金额小等于100元时，按正常票价收费<br />
             dayAllMoney+=dayMoney<br />
             m100+=dayMoney<br />
             t100+=1<br />
         elif dayAllMoney&lt;=150.0:  #总金额小等于150时，按正常票价的8折收费<br />
             dayAllMoney+=dayMoney*0.8<br />
             m150+=dayMoney*0.8<br />
             t150+=1<br />
         elif dayAllMoney&lt;=400.0: #总金额小等于400时，按正常票价的5折收费<br />
             dayAllMoney+=dayMoney*0.5<br />
             m400+=dayMoney*0.5<br />
             t400+=1<br />
         else :  #总金额超过400元，按正常票价收费<br />
             dayAllMoney+=dayMoney<br />
             mmax+=dayMoney<br />
             tmax+=1

         dayNowTime+=1 #乘车次数++

     return (dayMonth,dayTime,dayMoney,dayAllMoney,m100,t100,m150,t150,m400,t400,mmax,tmax)

 if __name__== '__main__':<br />
     (dm,dt,dy,dam,m100,t100,m150,t150,m400,t400,mmax,tmax)= way()

     print("\n")<br />
     print ("您该月共乘坐北京地铁 {0} 天，每天 {1} 次，单次乘车消费{2}元，共消费 {3:.2f} 元。".format(dm,dt,dy,dam))<br />
     print("\n")<br />
     print("月总消费额度100元阶段内: 共乘坐 {0} 次，阶段消费 {1:.2f} 元，共计 {2:.2f} 元。".format(t100,m100,m100))<br />
     print("月总消费额度150元阶段内: 共乘坐 {0} 次，阶段消费 {1:.2f} 元，共计 {2:.2f} 元。".format(t150,m150,m100+m150))<br />
     print("月总消费额度400元阶段内: 共乘坐 {0} 次，阶段消费 {1:.2f} 元，共计 {2:.2f} 元。".format(t400,m400,m100+m150+m400))<br />
     print("月总消费额度超过400元阶段内: 共乘坐 {0} 次，阶段消费 {1:.2f} 元，共计 {2:.2f} 元。".format(tmax,mmax,m100+m150+m400+mmax))<br />
     print("\n")</pre>
</div>
<p>测试结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/322940/201506/301700344311532.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k3z7qj.html">设计模式之单例模式的简单demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4p1m5q.html">jquery的show&sol;hide&sol;toggle详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlpw309.html">IIS发布网站遇到的异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p6j0dq.html">NYOJ题目65另一种阶乘问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd1lkm8.html">Linux之vi&sol;vim命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yo4g08.html">android通过服务实现消息推送</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjo4gz8.html">overlay</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy15m5mq.html">js移动端&sol;H5同时选择多张图片上传并使用canvas压缩图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljw5519.html">jQuery &equals;&equals;&equals; 面条式代码？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv17ynzq.html">ASP&period;NET Core学习之三 NLog日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd644k9.html">Spring源码情操陶冶-任务定时器ConcurrentTaskScheduler</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pne4v8.html">&lbrack;java面试&rsqb;宇信易诚 广州分公司 java笔试题目回忆录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo5zrnq.html">node概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gndomq.html">Web设计中打开新页面或页面跳转的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyylgygq.html">二、存储管理器--SDRAM</a>
		</li>
						<li><a href="https://www.batexi.com/a/960k1y49.html">DOM事件监听器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o1ppk8.html">RNN&sol;LSTM&sol;GRU&sol;seq2seq公式推导</a>
		</li>
						<li><a href="https://www.batexi.com/a/9601ng39.html">异步多线程 Task理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1mxmk9.html">ruby http爬虫中的 &colon;body 用法问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/953jpgv8.html">SQL Server 对比数据库差异</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/2q755019.html">Linux搭建SVN服务器&lpar;centos&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o66m18.html">android shape的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2z4doq.html">jQuery in action 3rd - Operating on a jQuery collection</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o6ejl8.html">Log4net日志GUI配置工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx37yvq.html">I535卡刷土豆修改4&period;1&period;2版本ROMV4過程</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jownwq.html">halcon摄像机标定</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2zo0wq.html">python递归次数和堆栈溢出问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvy6jzq.html">Keepalived&plus;tomcat的HA配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnx31x9.html">Magicodes&period;WeiChat&mdash;&mdash;媒体资源选择组件之media-choice（开源）</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4ox7j8.html">&lbrack;Xamarin&rsqb; 使用LayoutInflater&period;Inflate載入預先設計好的Layout並使用 （转帖）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
